/* Created by Richard Wade
 *
 * Control DC motors with a Smartphone via bluetooth
 * using a HC-05 module. The Rx on Arduino goes the the
 * Tx on the HC-05 and the Tx on Arduino goes the the
 * Rx on the HC-05. The Android App used with this set is
 * BlueStick Control.
 * 
*/

int motorPin1 = 3; // pin 1 on L293D
int motorPin2 = 4; // pin 2 on L293D
int motorPin3 = 5; // pin 3 on L293D
int motorPin4 = 6; // pin 4 on L293D
int enablePinR = 9; // pin A on L293D
int enablePinL = 10; // pin B on L293D
int state;
int flag=0;        //makes sure that the serial only prints once the state changes
 
void setup() {
    // sets the pins as outputs:
    pinMode(motorPin1, OUTPUT);
    pinMode(motorPin2, OUTPUT);
    pinMode(motorPin3, OUTPUT);
    pinMode(motorPin4, OUTPUT);
    pinMode(enablePinR, OUTPUT);
    pinMode(enablePinL, OUTPUT);
    // sets enablePin high so that motor can turn on:
    digitalWrite(enablePinR, HIGH);
    digitalWrite(enablePinL, HIGH);
    // initialize serial communication at 9600 bits per second:
    Serial.begin(9600);
}
 
void loop() {
    //if some date is sent, reads it and saves in state
    if(Serial.available() > 0){
      state = Serial.read();
      Serial.println(state);
      flag=0;
    }   
    // if the state is '0' the DC motor will turn off
    if (state == 48) {
        analogWrite(enablePinR, 0); // set pin 1 on L293D low
        analogWrite(enablePinL, 0); // set pin 1 on L293D low
        digitalWrite(motorPin1, LOW); // set pin 1 on L293D low
        digitalWrite(motorPin2, LOW); // set pin 2 on L293D low
        digitalWrite(motorPin3, LOW); // set pin 3 on L293D low
        digitalWrite(motorPin4, LOW); // set pin 4 on L293D low
        if(flag == 0){
          Serial.println("Motors: off");
          flag=1;
        }
    }
    // if the state is '56' the DC motors will turn on faward
    if (state == 56) {
        digitalWrite(motorPin1, HIGH); // set pin 1 on L293D HIGH
        digitalWrite(motorPin2, LOW); // set pin 2 on L293D low
        digitalWrite(motorPin3, HIGH); // set pin 3 on L293D HIGH
        digitalWrite(motorPin4, LOW); // set pin 4 on L293D low
        analogWrite(enablePinR, 100); // set pin 1 on L293D low
        analogWrite(enablePinL, 98); // set pin 1 on L293D low
        if(flag == 0){
          Serial.println("Both Motors: forward");
          flag=1;
        }
    }    
    // if the state is '52' the motor will turn right
    else if (state == 52) {
        digitalWrite(motorPin1, LOW); // set pin 1 on L293D HIGH
        digitalWrite(motorPin2, HIGH); // set pin 2 on L293D low
        digitalWrite(motorPin3, HIGH); // set pin 3 on L293D low
        digitalWrite(motorPin4, LOW); // set pin 4 on L293D low
        analogWrite(enablePinR, 60); // set pin 1 on L293D low
        analogWrite(enablePinL, 60); // set pin 1 on L293D low
        if(flag == 0){
          Serial.println("Motor: right");
          flag=1;
        }
    }
    // if the state is '54' the motor will turn left
    else if (state == 54) {
        digitalWrite(motorPin1, HIGH); // set pin 1 on L293D low
        digitalWrite(motorPin2, LOW); // set pin 2 on L293D HIGH
        digitalWrite(motorPin3, LOW); // set pin 3 on L293D HIGH
        digitalWrite(motorPin4, HIGH); // set pin 4 on L293D low
        analogWrite(enablePinR, 60); // set pin 1 on L293D low
        analogWrite(enablePinL, 60); // set pin 1 on L293D low
        if(flag == 0){
          Serial.println("Motor: left");
          flag=1;
        }
    }
    // if the state is '50' the motorS will turn BACKWARDS
    else if (state == 50) {
        digitalWrite(motorPin1, LOW); // set pin 1 on L293D low
        digitalWrite(motorPin2, HIGH); // set pin 2 on L293D HIGH
        digitalWrite(motorPin3, LOW); // set pin 3 on L293D HIGH
        digitalWrite(motorPin4, HIGH); // set pin 4 on L293D low
        analogWrite(enablePinR, 72); // set pin 1 on L293D low
        analogWrite(enablePinL, 70); // set pin 1 on L293D low
        if(flag == 0){
          Serial.println("Both Motors: backwards");
          flag=1;
        }
    }
}


